// HM62256 Static Ram

pub mod ramchip;
pub mod romchip;
pub mod tick;
pub mod default;
pub mod new;
pub mod dump;
mod control;
mod bus_device;
mod memory_chip;

use crate::constants::constants_system::SIZE_32KB;
use crate::traits::ram_chip::RamChip;
use crate::traits::rom_chip::RomChip;
use log::debug;

/// Hitachi Semiconductor
/// 8 Bit High Speed Static Ram
/// 32KByte
pub struct Hm62256 {
    pub(crate) offset: u16,
    pub(crate) max_offset: u16,
    pub(crate) data: Box<[u8]>,
    pub(crate) address_bus: u16,
    pub(crate) data_bus: u8,
    // Chip Select
    pub(crate) cs: bool,
    // Write Enable
    pub(crate) we: bool,
    // Output Enable
    pub(crate) oe: bool
}
